// CC BY
// code by SASANO Takayoshi

const unsigned char	*image_data;
const unsigned short	image_size;
const unsigned short	image_entry;

const unsigned char	*sprite_data;
const unsigned short	sprite_size;
const unsigned short	sprite_entry;

#define	isValidImageEntry(x)	(((x) >= 0) && ((x) < image_entry))
#define	get_image_data(x)	\
	(isValidImageEntry(x) ? (image_data + (x) * image_size) : NULL)

#define	isValidSpriteEntry(x)	(((x) >= 0) && ((x) < sprite_entry))
#define	get_sprite_data(x)	\
	(isValidSpriteEntry(x) ? (sprite_data + (x) * sprite_size) : NULL)
