// CC BY
// code by SASANO Takayoshi

static __inline	unsigned char	in_b(unsigned short port)
{
	unsigned char	data;
	__asm volatile("inb %1, %0" : "=a"(data) : "d"(port));
	return data;
}

static __inline	void	out_b(unsigned short port, unsigned char data)
{
	__asm volatile("outb %0, %1" :: "a"(data), "d"(port));
}

static __inline void	DI(void)
{
	__asm volatile("cli");
}

static __inline void	EI(void)
{
	__asm volatile("sti");
}

static __inline	void	set_es(unsigned short segment)
{
	__asm volatile("movw %0, %%es" :: "a"(segment));
}

static __inline unsigned short	get_cs(void)
{
	unsigned short	segment;
	__asm volatile("movw %%cs, %0" : "=a"(segment));
	return segment;
}

static __inline void	poke_w(unsigned short offset, unsigned short data)
{
	__asm volatile("movw %0, %%es:(%1)" :: "a"(data), "D"(offset));
}

static __inline	unsigned short	peek_w(unsigned short offset)
{
	unsigned short	data;
	__asm volatile("movw %%es:(%1), %0" : "=a"(data) : "D"(offset));
	return data;
}

static __inline void	halt(void)
{
	__asm volatile("hlt");
}
